import { ALIGN_CENTER } from '../drawer/BaseDrawer';
import { DrawingBox } from './GraphicBox';
export const ACTOR_MARGIN = 10;
export const ACTOR_PADDING = 10;
export class ActorGraphic {
    constructor(actor) {
        this.box = new DrawingBox();
        this.distance = [];
        this.paddingRight = 0;
        this.signalHeight = 0;
        this.actor = actor;
    }
    draw(drawer) {
        // draw top textbox
        drawer.drawTextBox(this.box, this.actor.name, ACTOR_MARGIN, ACTOR_PADDING, ALIGN_CENTER);
        // draw bottom textbox
        const bottomBox = this.box.clone();
        bottomBox.y = this.box.y + this.box.height + this.signalHeight;
        drawer.drawTextBox(bottomBox, this.actor.name, ACTOR_MARGIN, ACTOR_PADDING, ALIGN_CENTER);
        // draw vertical line
        const cX = this.box.getCenterX();
        drawer.drawLine(cX, this.box.y + this.box.height - ACTOR_MARGIN, cX, this.box.y + this.box.height + ACTOR_MARGIN + this.signalHeight);
    }
}
